
#include <iostream.h>
#include <malloc.h>
#include <string.h>
#include "yakwin.h"
#include "yakMouse.h"
#include "xlib.h"
#include "xpbitmap.h"
#include "xrect.h"
#include "xtext.h"
#include "xline.h"
#include <conio.h>
				
extern yakMouse mouse;

yakWindow * yakWindow::killPointer = NULL;

//yakWindowPane functions follow------------------------------------->
yakWindowPane::yakWindowPane(word x1, word y1, word x2, word y2)
{
	width = x2-x1;
	bWidth = (width + (((4-(width % 4)) == 4) ? 0 : (4-(width%4))))/4; 
//smallest mult of 4 > width!
	x=x1; y=y1; height = y2-y1;
	myGraphicData = NULL;
	myGraphicData2 = NULL;
}

void yakWindowPane::save(word x1, word y1, word ioffset)
{
	if (myGraphicData) {
		delete myGraphicData;
		myGraphicData = NULL;
	}
	if (myGraphicData2) {
		delete myGraphicData2;
		myGraphicData2 = NULL;
	}
	x = x1; y = y1; myOffset = ioffset;
	if (!myGraphicData) {
		// check and see if the background image fits in 64k
		unsigned long size = (unsigned long)bWidth*4*(unsigned long)height + 4;
		if (size <= (63L*1024L)) {
			myGraphicData = new byte[size];
			x_get_pbm(x1, y1, bWidth, height, myOffset, myGraphicData);
		}
		else {
			myGraphicData = new byte[bWidth*4*(height/2) + 4];
			myGraphicData2 = new byte[bWidth*4*(height-(height/2)) + 4];
			x_get_pbm(x1, y1, bWidth, height/2, myOffset, myGraphicData);
			x_get_pbm(x1, y1+(height/2), bWidth, height - (height/2), myOffset,
myGraphicData2);
		}
	}
	if (myGraphicData == NULL)
		exit(EXIT_FAILURE);
}

void yakWindowPane::save(void)
{
	// save from HiddenPage since that is the only
	// page you should be drawing to.
	save(x,y,HiddenPageOffs);
}

void yakWindowPane::restore(word ioffset)
{
	if (myGraphicData == NULL)
		exit(EXIT_FAILURE);
	x_put_pbm(x, y, ioffset, myGraphicData);
	if (myGraphicData2)
		x_put_pbm(x, y+(height/2), ioffset, myGraphicData2);
}

void yakWindowPane::restore(void)
{
	if (VisiblePageOffs != HiddenPageOffs) {
		restore(HiddenPageOffs);
		x_page_flip(PhysicalStartPixelX, PhysicalStartY);
		restore(HiddenPageOffs);
	}
	else restore(VisiblePageOffs);
}

//yakWindow definitions follow--------------------------------------->

yakWindow * yakWindow::topWindow = NULL;
yakWindow * yakWindow::bottomWindow = NULL;
yakWindow * yakWindow::activeWindow = NULL;

yakWindow::yakWindow(int x1, int y1, int x2, int y2) :
yakWindowPane(x1, y1, x2, y2)
{
	myOffset = VisiblePageOffs;
	textColor = 15;
	titleBarColor = 63;
	boxColor = 0;
	title[0]= 0;
	myFlags = isSizeable | isDraggable | isCloseable;
}


void yakWindow::open(void) //can only open on top...
{
	mouse.hide();
	// are we the bottom window?
	if (bottomWindow == NULL) {
		bottomWindow = this;
		prevWindow = NULL;
		nextWindow = NULL;
	}
	// is there a top window?
	if (topWindow) {
		topWindow->showDeActivated();
		topWindow->nextWindow = this;
		prevWindow = topWindow;
		nextWindow = NULL;
	}
	topWindow = this;
	save();
	draw();
	showActivated();
	activeWindow = this;
	mouse.show();
}

void yakWindow::close(void)  //can only close on top too.
{
	mouse.hide();
	if (topWindow != this)
		shuffleToTop();       //now we know we're topWindow.
	topWindow = prevWindow; //which should be null if we're on bottom.
	if (bottomWindow == this)
		bottomWindow = NULL;  //we're closing the last window.
	if (topWindow)          //if there's still a top window,
		topWindow->nextWindow = NULL;  //make sure it doesn't think there's a next!
	restore();
	if (myGraphicData) {
		delete myGraphicData;
		myGraphicData = NULL;
	}
	if (myGraphicData2) {
		delete myGraphicData2;
		myGraphicData2 = NULL;
	}
	activeWindow = topWindow;
	topWindow->showActivated();
	if (myFlags & isTemporary)
		killPointer = this;
	mouse.show();
}

void yakWindow::shuffleToTop(void)
{
	mouse.hide(); //so we don't disrupt everything!
	yakWindow * myYakWindowPointer = topWindow;
	// if there're no windows, we can't do much!
	if (myYakWindowPointer == NULL) {
		mouse.show();
		return;
	}
	// are we already on top?
	if (myYakWindowPointer == this) {
		mouse.show();
		return;
	}
	// erase windows on hidden page, top->bottom
	while (myYakWindowPointer != NULL) {
		myYakWindowPointer->restore(HiddenPageOffs);
		myYakWindowPointer = myYakWindowPointer->prevWindow;
	}
	myYakWindowPointer = bottomWindow;
	int inlist = 0; // is this already in the window list?
	// draw windows on hidden page, bottom->top
	while (myYakWindowPointer != NULL) {
		if (myYakWindowPointer != this) {
			if (VisiblePageOffs == HiddenPageOffs)
				myYakWindowPointer->save();
			myYakWindowPointer->draw(HiddenPageOffs);
		}
		else inlist = 1;
		myYakWindowPointer = myYakWindowPointer->nextWindow;
	}
	// are we using two pages?
	if (VisiblePageOffs != HiddenPageOffs) {
		draw(HiddenPageOffs);
		x_page_flip(PhysicalStartPixelX, PhysicalStartY);
		myYakWindowPointer = topWindow;
		// erase windows on hidden page, top->bottom
		while (myYakWindowPointer != NULL) {
			myYakWindowPointer->restore(HiddenPageOffs);
			myYakWindowPointer = myYakWindowPointer->prevWindow;
		}
		myYakWindowPointer = bottomWindow;
		// draw windows on hidden page, bottom->top
		while (myYakWindowPointer != NULL) {
			if (myYakWindowPointer != this) {
				myYakWindowPointer->save();
				myYakWindowPointer->draw(HiddenPageOffs);
			}
			myYakWindowPointer = myYakWindowPointer->nextWindow;
		}
	}
	// if it is in the window list then remove it
	if (inlist) {
		// are we the bottom?
		if (prevWindow)
			prevWindow->nextWindow = nextWindow;
		else
			bottomWindow = nextWindow;
		if (nextWindow)
			nextWindow->prevWindow = prevWindow;
	}
	// add this window at the top of the list
	// are we the bottom window?
	if (bottomWindow == NULL) {
		bottomWindow = this;
		prevWindow = NULL;
		nextWindow = NULL;
	}
	// is there a top window?
	if (topWindow) {
		topWindow->nextWindow = this;
		prevWindow = topWindow;
		nextWindow = NULL;
	}
	topWindow = this;
	save();
	draw(HiddenPageOffs);
	showActivated();
	activeWindow = this;
	mouse.show();
}

void yakWindow::drawAll(void)
{
	yakWindow * myYakWindowPointer = bottomWindow;
	// are there any windows?
	if (myYakWindowPointer) {
		// draw all windows on hidden page, bottom->top
		while (myYakWindowPointer != NULL) {
			myYakWindowPointer->save();
			myYakWindowPointer->draw(HiddenPageOffs);
			myYakWindowPointer = myYakWindowPointer->nextWindow;
		}
		if (HiddenPageOffs != VisiblePageOffs) {
			myYakWindowPointer = bottomWindow;
			x_page_flip(PhysicalStartPixelX, PhysicalStartY);
			// draw all windows on hidden page, bottom->top
			while (myYakWindowPointer != NULL) {
				myYakWindowPointer->draw(HiddenPageOffs);
				myYakWindowPointer = myYakWindowPointer->nextWindow;
			}
		}
	}
}

void yakWindow::draw(word offset)
{
	x = x;
	y = y;
	x_rect_fill(x, y, x+width, y+height, offset, 10);
	x_rect_fill(x+2, y+2, x+width-2, y+height-2, offset, boxColor);
	x_line(x,y, x+width-1, y, 15, offset); //top
	x_line(x,y, x, y+height-1, 15, offset); //left
	x_line(x,y+height-1, x+width-1, y+height-1, 5, offset); //bottom
	x_line(x+width-1,y, x+width-1, y+height-1, 5, offset); //right
	x_line(x+width - 2, y + height - 4, x+width-1, y+height - 4, 0,
offset); //size box
	x_line(x+width - 4, y+height - 2, x+width-4, y+height-1, 0, offset);
//size box
	x_line(x+3, y, x+3, y+2, 0, offset); //close box
	x_line(x, y+3, x+2, y+3, 0, offset); //close box
	showDeActivated(offset);
}

void yakWindow::draw(void)
{
	draw(HiddenPageOffs);
	if (VisiblePageOffs != HiddenPageOffs) {
		x_page_flip(PhysicalStartPixelX, PhysicalStartY);
		draw(HiddenPageOffs);
	}
}

void yakWindow::showActivated(word offset)
{
	x_rect_fill(x+2, y+2, x+width - 2, y+2+CharHeight, offset, titleBarColor);
	x_bgprintf(x+2, y+2, offset, textColor, titleBarColor, title);
}

void yakWindow::showActivated(void)
{
	showActivated(HiddenPageOffs);
	if (VisiblePageOffs != HiddenPageOffs) {
		x_page_flip(PhysicalStartPixelX, PhysicalStartY);
		showActivated(HiddenPageOffs);
	}
}

void yakWindow::showDeActivated(word offset)
{
	x_rect_fill(x+2, y+2, x+width - 2, y+2+CharHeight, offset, titleBarColor-5);
	x_bgprintf(x+2, y+2, offset, textColor-5, titleBarColor-5, title);
}

void yakWindow::showDeActivated(void)
{
	showDeActivated(HiddenPageOffs);
	if (VisiblePageOffs != HiddenPageOffs) {
		x_page_flip(PhysicalStartPixelX, PhysicalStartY);
		showDeActivated(HiddenPageOffs);
	}
}

word yakWindow::interpretMouseClick(void)
{
	// nested if's since we want each click to
	// only do one thing
	if (isDragSelected())
		drag();
	else if (isSizeSelected())
			size();
	else if (isCloseSelected())
			close();
	return 0;
}

word yakWindow::interpretKeyStroke(char myChar)
{
	return 0;
}

void yakWindow::drag(void)
{
	int oldX = mouse.x();
	int oldY = mouse.y();
	int deltaX, deltaY;
	int myoldX, myoldY;
	int newX,newY;

	mouse.hide();
	while(mouse.isPressed(yakMouse::leftButton))
	{
		deltaX = mouse.x() - oldX;
		deltaY = mouse.y() - oldY;
		// did the mouse move?
		if (deltaX!=0 || deltaY!=0) {
			oldX = mouse.x();
			oldY = mouse.y();
			// save current posn
			myoldX=x;
			myoldY=y;
			restore(HiddenPageOffs);
			// calculate new x value using as much of deltaX as possible
			if  (((int)x + deltaX) <= 0)
				x=0;
			else if (((int)x + deltaX + width) >= ScrnLogicalPixelWidth)
				x=ScrnLogicalPixelWidth - width;
				else x+=deltaX;
			// calculate new y value using as much of deltaY as possible
			if (((int)y + deltaY) <= 0)
				y=0;
			else if (((int)y + deltaY + height) >= ScrnLogicalHeight)
				y=ScrnLogicalHeight - height;
			else y+=deltaY;
			// save new posn
			newX=x;
			newY=y;
			if (VisiblePageOffs == HiddenPageOffs)
				save(x,y,HiddenPageOffs);
			draw(HiddenPageOffs);
			showActivated(HiddenPageOffs);
			if (VisiblePageOffs != HiddenPageOffs) {
				x_page_flip(PhysicalStartPixelX,PhysicalStartY);
				// restore old posn
				x=myoldX;
				y=myoldY;
				restore(HiddenPageOffs);
				// restore new posn
				x=newX;
				y=newY;
				save(x,y,HiddenPageOffs);
				draw(HiddenPageOffs);
				showActivated(HiddenPageOffs);
			}
		}
	}
	mouse.show();
}

void yakWindow::size(void)
{
	int oldX = mouse.x();
	int oldY = mouse.y();
	int deltaX, deltaY;
	int oldwidth,oldheight,oldbWidth;
	int newwidth,newheight,newbWidth;

	mouse.hide();
	while(mouse.isPressed(yakMouse::leftButton))
	{
		deltaX = mouse.x() - oldX;
		deltaY = mouse.y() - oldY;
		// did the mouse move?
		if (deltaX != 0 || deltaY != 0) {
			// save current mouse posn
			oldX = mouse.x();
			oldY = mouse.y();
			restore(HiddenPageOffs);
			// save current values
			oldwidth=width;
			oldbWidth=bWidth;
			oldheight=height;
			// calculate new width using as much of deltaX as possible
			if (((int)width + deltaX) < (strlen(title)*CharWidth + 4))
				width = strlen(title)*CharWidth + 4;
			else if (((int)x + deltaX + (int)width) > ScrnLogicalPixelWidth)
					width = ScrnLogicalPixelWidth-(int)x-1;
				else width+=deltaX;
			bWidth = ((int)width + (((4-((int)width % 4)) == 4) ? 0 :
(4-((int)width%4))))/4;  //smallest mult of 4 > width!
			// calculate new height using as much of deltaY as possible
			if (((int)height + deltaY) < (CharHeight + 4))
				height = CharHeight + 4;
			else if (((int)y + deltaY + (int)height) > ScrnLogicalHeight)
					height = ScrnLogicalHeight-(int)y-1;
				else height+=deltaY;
			// save new values
			newwidth=width;
			newbWidth=bWidth;
			newheight=height;

			if (VisiblePageOffs == HiddenPageOffs)
				save(x,y,HiddenPageOffs);
			draw(HiddenPageOffs);
			showActivated(HiddenPageOffs);
			if (VisiblePageOffs != HiddenPageOffs) {
				x_page_flip(PhysicalStartPixelX, PhysicalStartY);
				// restore old values
				height=oldheight;
				bWidth=oldbWidth;
				width=oldwidth;
				restore(HiddenPageOffs);
				// restore new values
				width=newwidth;
				bWidth=newbWidth;
				height=newheight;
				save(x,y,HiddenPageOffs);
				draw(HiddenPageOffs);
				showActivated(HiddenPageOffs);
			}
		}
	}
	mouse.show();
}

int yakWindow::isSelected(void)
{
	if (mouse.isInBox(x, y, x + width, y + height) &&
mouse.isPressed(yakMouse::leftButton))
		return 1;
	else return 0;
}

int yakWindow::isDragSelected(void)
{
	if (mouse.isInBox(x+2, y+2, x + width-2, y + 2 + CharHeight) &&
mouse.isPressed(yakMouse::leftButton) && (myFlags & isDraggable))
		return 1;
	else return 0;
}

int yakWindow::isSizeSelected(void)
{
	if (mouse.isInBox(x+width-5, y+height-5, x+width, y+height) &&
	!mouse.isInBox(x+width-5, y+height-5, x+width-3, y+height-3) &&
	(myFlags & isSizeable))
		return 1;
	else return 0;
}

int yakWindow::isCloseSelected(void)
{
	if (mouse.isInBox(x, y, x+5, y+5) &&
	!mouse.isInBox(x+2, y+2, x+5, y+5) &&
	(myFlags & isCloseable))
		return 1;
	else return 0;
}

void yakWindow::selectToTop(void)
{
	yakWindow * myYakWindowPointer = topWindow;
	while (myYakWindowPointer != NULL)
	{
		if (myYakWindowPointer->isSelected())
	 break;
		myYakWindowPointer = myYakWindowPointer->prevWindow;
	}
	activeWindow = myYakWindowPointer;
	mouse.hide();
	if (activeWindow)
	{
		myYakWindowPointer->shuffleToTop();
		activeWindow->showActivated();
	}
	else
		topWindow->showDeActivated();
	mouse.show();
}

word yakWindow::advance(void)
{
	if (killPointer)
	{
		delete killPointer;
		killPointer = NULL; //delete the "killed" window
	}
	if (mouse.isPressed(yakMouse::eitherButton))
	{
//    if (mouse.isPressed(yakMouse::leftButton))
	 selectToTop();
		if (activeWindow)
	 return activeWindow->interpretMouseClick();
	}
	if (kbhit() && activeWindow)
		return(activeWindow->interpretKeyStroke(getch()));
	if (!(mouse.isPressed(yakMouse::eitherButton)))
		mouse.isClicked(yakMouse::reset);
	return 0;
}

